#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <alloca.h>
#include <wchar.h>


//----------------------------------------------------------

void test01( void ) {
   int i = 0;        // начало стека локальных переменных
   char *str1 = "string1",
         str2[] = "string2",
         str3[ 40 ] = "string3";
   printf( "начало стека локальных переменных: %p\n", &i );
   printf( "%d[%p] %d[%p] %d[%p]\n", 
           sizeof( str1 ), str1, sizeof( str2 ), str2, sizeof( str3 ), str3 );         
};

//----------------------------------------------------------

void test02( void ) {
   int i = 0;        // начало стека локальных переменных
   char *str1 = "pointer",
         str2[] = "array",
        *str3, *str4, *str5; // [ 40 ] = "string3";
   printf( "начало стека локальных переменных: %p\n", &i );
   str3 = strdup( "strdup" );
   str4 = malloc( strlen( "malloc" ) + 1 ); strcpy( str4, "malloc" );
   str5 = alloca( strlen( "alloca" ) + 1 ); strcpy( str5, "alloca" );
   printf( "1(%s)\t=> %p\n2(%s)\t=> %p\n3(%s)\t=> %p\n"
           "4(%s)\t=> %p\n5(%s)\t=> %p\n",
           str1, str1, str2, str2, str3, str3,
           str4, str4, str5, str5 );         
   free( str3 );
   free( str4 );     // str5 не удаляется!
};

//----------------------------------------------------------

// символьные строки:
int main () {
   void ( *tests[] )( void ) = {  // последовательность тестов
      test01, test02 /*, test03, test04, test05, test06 */
   };
   int i;
   for( i = 0; i < sizeof( tests ) / sizeof( tests[ 0 ] ); i++ )
      tests[ i ]();
   return 0;
}

